// Generated by KLFC 1.5.7
// https://github.com/39aldo39/klfc

#include "unimap_trans.h"
#include "action_util.h"
#include "action_layer.h"

enum function_id {
    F_MODIFIER,
};

enum macro_id {
    LIG__asciicircum_,
    LIG__asterisk_,
    LIG__grave_,
    LIG__equal_,
};

enum modifier_id {
    MOD_SHIFT,
    MOD_SHIFT_L,
    MOD_SHIFT_R,
};

#define AC_FN0 ACTION_MACRO(LIG__asciicircum_)
#define AC_FN1 ACTION_MACRO(LIG__asterisk_)
#define AC_FN2 ACTION_FUNCTION_OPT(F_MODIFIER, MOD_SHIFT_L)
#define AC_FN3 ACTION_FUNCTION_OPT(F_MODIFIER, MOD_SHIFT_R)
#define AC_FN4 ACTION_MACRO(LIG__grave_)
#define AC_FN5 ACTION_MACRO(LIG__equal_)

#ifdef KEYMAP_SECTION_ENABLE
const action_t actionmaps[][UNIMAP_ROWS][UNIMAP_COLS] __attribute__ ((section (".keymap.keymaps"))) = {
#else
const action_t actionmaps[][UNIMAP_ROWS][UNIMAP_COLS] PROGMEM = {
#endif
    // None
    [0] = UNIMAP(
               F13, F14, F15, F16, F17, F18, F19, F20, F21, F22, F23, F24,
     ESC,       F1,  F2,  F3,  F4,  F5,  F6,  F7,  F8,  F9, F10, F11, F12,          PSCR,SLCK,PAUS,         VOLD,VOLU,MUTE,
     FN0,   1,   2,   3,   4,   5,   6,   7,   8,   9,   0, FN1,BSLS,JYEN,BSPC,      INS,HOME,PGUP,    NLCK,PSLS,PAST,PMNS,
     TAB,   J,   G,   H,   P,   F,   Q,   V,   O,   U,SCLN,SLSH,LBRC,     RBRC,      DEL, END,PGDN,      P7,  P8,  P9,PPLS,
    CAPS,   R,   S,   N,   T,   K,   Y,   I,   A,   E,   L,MINS,     NUHS, ENT,                          P4,  P5,  P6,PCMM,
     FN2,NUBS,   Z,   W,   M,   D,   B,   C,COMM,QUOT, DOT,   X,       RO, FN3,            UP,           P1,  P2,  P3,PENT,
    LCTL,LGUI,LALT,MHEN,           SPC,          HENK,KANA,RALT,RGUI, APP,RCTL,     LEFT,DOWN,RGHT,      P0,     PDOT,PEQL
    ),
    // Shift
    [1] = UNIMAP(
              TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,
    TRNS,     TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,          TRNS,TRNS,TRNS,         TRNS,TRNS,TRNS,
     GRV,TRNS,TRNS,TRNS,TRNS,TRNS,   7, FN4,   9,   0, FN5, EQL,TRNS,TRNS,TRNS,     TRNS,TRNS,TRNS,    TRNS,TRNS,TRNS,TRNS,
    TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,     TRNS,     TRNS,TRNS,TRNS,    TRNS,TRNS,TRNS,TRNS,
    TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,     TRNS,TRNS,                        TRNS,TRNS,TRNS,TRNS,
    TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,     TRNS,TRNS,          TRNS,         TRNS,TRNS,TRNS,TRNS,
    TRNS,TRNS,TRNS,TRNS,          TRNS,          TRNS,TRNS,TRNS,TRNS,TRNS,TRNS,     TRNS,TRNS,TRNS,    TRNS,     TRNS,TRNS
    ),
};

const macro_t *action_get_macro(keyrecord_t *record, uint8_t id, uint8_t opt) {
    switch (id) {
        case LIG__asciicircum_:
            return record->event.pressed ?
                   MACRO(SM(), CM(), D(LSFT), T(6), U(LSFT), RM(), END) :
                   MACRO_NONE;
        case LIG__asterisk_:
            return record->event.pressed ?
                   MACRO(SM(), CM(), D(LSFT), T(8), U(LSFT), RM(), END) :
                   MACRO_NONE;
        case LIG__grave_:
            return record->event.pressed ?
                   MACRO(SM(), CM(), T(GRV), RM(), END) :
                   MACRO_NONE;
        case LIG__equal_:
            return record->event.pressed ?
                   MACRO(SM(), CM(), T(EQL), RM(), END) :
                   MACRO_NONE;
    }
    return MACRO_NONE;
}

#define MOD_SHIFT_MASK (MOD_BIT(KC_LSFT)|MOD_BIT(KC_RSFT))

uint8_t vmods = 0;

const uint8_t layer_states[] = {
    0x1, // None
    0x3, // Shift
};

void action_function(keyrecord_t *record, uint8_t id, uint8_t opt) {
    uint8_t pressed = record->event.pressed;
    switch (id) {
        case F_MODIFIER:
            // Set the new modifier
            switch (opt) {
                case MOD_SHIFT: pressed ? add_key(KC_LSFT) : del_key(KC_LSFT); break;
                case MOD_SHIFT_L: pressed ? add_key(KC_LSFT) : del_key(KC_LSFT); break;
                case MOD_SHIFT_R: pressed ? add_key(KC_RSFT) : del_key(KC_RSFT); break;
            }

            // Update the layer
            uint8_t mods = get_mods();
            uint8_t layer_index = 0;
            layer_index |= mods & MOD_SHIFT_MASK ? 1 : 0;
            layer_index |= vmods << 1;
            layer_clear();
            layer_or(layer_states[layer_index]);
            break;
    }
}
